diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
index 955c11139..00fc5385a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
@@ -12,6 +12,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
@@ -47,7 +48,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
         addDispatch("bubble", new ParticleEntry() {
             @Override
             public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, true);
+                return new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, Dimension.getDimensionList().getOrDefault(data, Dimension.OVERWORLD), true);
             }
         });
         addDispatch("bubbleboiling", new ParticleEntry() {
@@ -113,7 +114,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
         addDispatch("splash", new ParticleEntry() {
             @Override
             public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleSplash(world, x, y, z, motionX, motionY, motionZ);
+                return new ParticleSplash(world, x, y, z, motionX, motionY, motionZ, Dimension.getDimensionList().getOrDefault(data, Dimension.OVERWORLD));
             }
         });
         addDispatch("largesmoke", new ParticleEntry() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSplash.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSplash.java
index ba55ca638..5f652edba 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSplash.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSplash.java
@@ -1,10 +1,12 @@
 package net.minecraft.client.render.particle;
 
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class ParticleSplash extends ParticleWaterDrop {
-    public ParticleSplash(World world, double x, double y, double z, double xa, double ya, double za) {
-        super(world, x, y, z);
+    public ParticleSplash(World world, double x, double y, double z, double xa, double ya, double za, @NotNull Dimension dimension) {
+        super(world, x, y, z, dimension);
         this.gravity = 0.04F;
         if (ya == 0.0D && (xa != 0.0D || za != 0.0D)) {
             this.xd = xa;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleWaterDrop.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleWaterDrop.java
index 415620843..7303d06d1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleWaterDrop.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleWaterDrop.java
@@ -4,11 +4,13 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
 
 public class ParticleWaterDrop extends Particle {
-    public ParticleWaterDrop(World world, double x, double y, double z) {
+    public ParticleWaterDrop(World world, double x, double y, double z, @NotNull Dimension dimension) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
         this.xd *= 0.3D;
         this.yd = (float) Math.random() * 0.2F + 0.1F;
@@ -16,7 +18,7 @@ public class ParticleWaterDrop extends Particle {
         this.rCol = 1.0F;
         this.gCol = 1.0F;
         this.bCol = 1.0F;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/splash_rain_" + random.nextInt(4));
+        this.tex = TextureRegistry.getTexture((dimension == Dimension.NETHER ? "minecraft:particle/splash_rain_blood_" : "minecraft:particle/splash_rain_") + random.nextInt(4));
         this.gravity = 0.06F;
         this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D));
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java
index be7dd11e3..c0990da79 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderHelper.java
@@ -75,9 +75,9 @@ public final class ShaderHelper {
         shader.uniformFloat("frameTimeCounter", frameTimeCounter);
         shader.uniformFloat("gamma", GameSettings.GAMMA.value);
         shader.uniformFloat("fxaa", GameSettings.FXAA.value);
-        shader.uniformFloat("heatHaze", GameSettings.HEAT_HAZE.value ? minecraft.ppm.lerped.heatHaze : 0.0f);
+        shader.uniformFloat("heatHaze", (GameSettings.HEAT_HAZE.value != 0) ? minecraft.ppm.lerped.heatHaze : 0.0f);
         shader.uniformInt("bloom", GameSettings.BLOOM.value);
-        shader.uniformInt("dimension", minecraft.currentWorld != null && minecraft.currentWorld.dimension != null ? minecraft.currentWorld.dimension.id : 0);
+        shader.uniformInt("dimension", minecraft.currentWorld != null ? minecraft.currentWorld.dimension.id : 0);
         shader.uniformInt("cbCorrectionMode", GameSettings.COLORBLINDNESS_FIX.value.ordinal());
 
         ItemStack helmet = minecraft.thePlayer == null ? null : minecraft.thePlayer.getItemInArmorSlot(HumanArmorShape.HEAD);
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
index 2feb5149a..55a79d076 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
@@ -11,8 +11,6 @@ import java.util.function.Supplier;
 import com.mojang.logging.LogUtils;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.shader.ShadersRenderer;
-import net.minecraft.client.render.shader.framebuffer.FrameBuffer;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL41;
@@ -65,13 +63,7 @@ public class ScreenShot
                 id++;
             }
 
-            final @Nullable FrameBuffer frameBuffer = ((ShadersRenderer) mc.renderer).getGameFrameBuffer();
-            if (frameBuffer == null) {
-                throw new IllegalStateException("Game frame buffer is null!");
-            }
-
-            // Bind framebuffer and PBO
-            frameBuffer.bind();
+            // Bind PBO
             GL41.glBindBuffer(GL41.GL_PIXEL_PACK_BUFFER, transferPbo);
 
             // Insert fence
@@ -82,8 +74,7 @@ public class ScreenShot
             GL41.glPixelStorei(GL41.GL_UNPACK_ALIGNMENT, 1);
             GL41.glReadPixels(0, 0, width, height, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, 0);
 
-            // Unbind framebuffer and PBO
-            frameBuffer.unbind();
+            // Unbind PBO
             GL41.glBindBuffer(GL41.GL_PIXEL_PACK_BUFFER, 0);
 
         } catch(Exception exception) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
index e73cf95b5..025325c56 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDispenser.java
@@ -52,7 +52,8 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
         final int zOffset = direction.getOffsetZ();
 
         final @NotNull TileEntityDispenser tileEntity = (TileEntityDispenser) Objects.requireNonNull(world.getTileEntity(tilePos));
-        final @Nullable ItemStack itemStack = tileEntity.getRandomStackFromInventory();
+        int stackIndex = tileEntity.getRandomStackIndexFromInventory();
+        final @Nullable ItemStack itemStack = stackIndex >= 0 ? tileEntity.getItem(stackIndex) : null;
         final @NotNull Vector3dc pos = new Vector3d(tilePos.x(), tilePos.y(), tilePos.z()).add(xOffset * 0.6 + 0.5, yOffset * 0.6 + 0.5, zOffset * 0.6 + 0.5);
         if (itemStack == null) {
             world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_EMPTY, 0);
@@ -61,35 +62,44 @@ public class BlockLogicDispenser extends BlockLogicVeryRotatable {
                 dispensable.onDispensed(itemStack, world, random, direction, pos.x(), pos.y(), pos.z());
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PROJECTILE, 0);
             } else if (itemStack.itemID == Items.AMMO_ARROW.id || itemStack.itemID == Items.AMMO_ARROW_GOLD.id) {
-                final @NotNull ProjectileArrow arrow;
-                if (itemStack.itemID == Items.AMMO_ARROW.id) {
-                    arrow = new ProjectileArrow(world, pos.x(), pos.y(), pos.z(), 0);
-                } else {
-                    arrow = new ProjectileArrowGolden(world, pos.x(), pos.y(), pos.z());
+                if (itemStack.consumeItem(null)) {
+                    final @NotNull ProjectileArrow arrow;
+                    if (itemStack.itemID == Items.AMMO_ARROW.id) {
+                        arrow = new ProjectileArrow(world, pos.x(), pos.y(), pos.z(), 0);
+                    } else {
+                        arrow = new ProjectileArrowGolden(world, pos.x(), pos.y(), pos.z());
+                    }
+                    arrow.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
+                    arrow.setDoesArrowBelongToPlayer(true);
+                    world.entityJoinedWorld(arrow);
                 }
-                arrow.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
-                arrow.setDoesArrowBelongToPlayer(true);
-                world.entityJoinedWorld(arrow);
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PROJECTILE, 0);
             } else if (itemStack.itemID == Items.AMMO_CHARGE_EXPLOSIVE.id) {
-                final @NotNull ProjectileCannonball projectileCannonball = new ProjectileCannonball(world, pos.x(), pos.y(), pos.z());
-                projectileCannonball.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
-                world.entityJoinedWorld(projectileCannonball);
+                if (itemStack.consumeItem(null)) {
+                    final @NotNull ProjectileCannonball projectileCannonball = new ProjectileCannonball(world, pos.x(), pos.y(), pos.z());
+                    projectileCannonball.setHeading(xOffset, yOffset + 0.1D, zOffset, 1.1F, 6F);
+                    world.entityJoinedWorld(projectileCannonball);
+                }
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PROJECTILE, 0);
             } else {
-                final @NotNull EntityItem item = new EntityItem(world, pos.x(), pos.y() + (direction == Direction.UP ? 0.25d : -0.3D), pos.z(), itemStack);
-                final double randOffset = random.nextDouble() * 0.1D + 0.2D;
-                item.xd = (double) xOffset * randOffset;
-                item.yd = (double) yOffset + (direction == Direction.UP ? -0.65D : 0.2D);
-                item.zd = (double) zOffset * randOffset;
-                item.xd += random.nextGaussian() * 0.0075D * 6D;
-                item.yd += random.nextGaussian() * 0.0075D * 6D;
-                item.zd += random.nextGaussian() * 0.0075D * 6D;
-                world.entityJoinedWorld(item);
+                if (itemStack.consumeItem(null)) {
+                    final @NotNull EntityItem item = new EntityItem(world, pos.x(), pos.y() + (direction == Direction.UP ? 0.25d : -0.3D), pos.z(), new ItemStack(itemStack.getItem()));
+                    final double randOffset = random.nextDouble() * 0.1D + 0.2D;
+                    item.xd = (double) xOffset * randOffset;
+                    item.yd = (double) yOffset + (direction == Direction.UP ? -0.65D : 0.2D);
+                    item.zd = (double) zOffset * randOffset;
+                    item.xd += random.nextGaussian() * 0.0075D * 6D;
+                    item.yd += random.nextGaussian() * 0.0075D * 6D;
+                    item.zd += random.nextGaussian() * 0.0075D * 6D;
+                    world.entityJoinedWorld(item);
+                }
                 world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_ITEM, 0);
             }
             world.playBlockEvent(tilePos, LevelListener.EVENT_DISPENSER_PARTICLES, direction.getId());
         }
+        if (stackIndex >= 0 && itemStack != null && itemStack.stackSize <= 0) {
+            tileEntity.setItem(stackIndex, null);
+        }
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index 8d204d005..6568dc84f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -142,7 +142,7 @@ public class BlockLogicFarmland
 
     @Override
     public void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity walker) {
-        if (world.rand.nextInt(4) == 0) {
+        if (world.rand.nextInt(4) == 0 && !world.isClientSide) {
             if (walker instanceof final @NotNull Player player) {
                 final @Nullable ItemStack bootsSlotStack = player.getItemInArmorSlot(HumanArmorShape.BOOTS);
                 if (bootsSlotStack != null && bootsSlotStack.getItem() == Items.ARMOR_BOOTS_LEATHER) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index ed57f4a23..49e76fa40 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1123,15 +1123,15 @@ public final class Blocks {
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block<?> RUBYGLASS_COLUMN = register("rubyglass.column", "minecraft:block/rubyglass_column", 821, (b) -> new BlockLogicRubyglass(b))
-        .withSound(BlockSounds.GLASS).withHardness(3F).withLightEmission(0.8F)
+        .withSound(BlockSounds.GLASS).withHardness(3F).withLightEmission(0.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
         .withOverrideColor(MaterialColor.rubyglass);
     public static final Block<?> BLOCK_RUBYGLASS = register("block.rubyglass", "minecraft:block/block_rubyglass", 822, (b) -> new BlockLogicTransparent(b, Materials.STONE))
-        .withSound(BlockSounds.GLASS).withHardness(3F).withLightEmission(0.8F)
+        .withSound(BlockSounds.GLASS).withHardness(3F).withLightEmission(0.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
         .withOverrideColor(MaterialColor.rubyglass);
     public static final Block<?> RUBYGLASS_SPROUT = register("rubyglass.sprout", "minecraft:block/rubyglass_sprout", 823, (b) -> new BlockLogicRubyglassSprout(b))
-        .withSound(BlockSounds.GLASS).withDisabledNeighborNotifyOnMetadataChange().withLightEmission(0.8F)
+        .withSound(BlockSounds.GLASS).withDisabledNeighborNotifyOnMetadataChange().withLightEmission(0.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
         .withOverrideColor(MaterialColor.rubyglass);
     public static final Block<?> RUBYGLASS_CIRCUIT = register("rubyglass.circuit", "minecraft:block/rubyglass_circuit", 824, (b) -> new BlockLogic(b, Materials.STONE))
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index 28def0062..dd7fa3cd0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -96,6 +96,20 @@ public class TileEntityDispenser extends TileEntity
         }
     }
 
+    public int getRandomStackIndexFromInventory()
+    {
+        int i = -1;
+        int j = 1;
+        for(int k = 0; k < dispenserContents.length; k++)
+        {
+            if(dispenserContents[k] != null && random.nextInt(j++) == 0)
+            {
+                i = k;
+            }
+        }
+        return i;
+    }
+
     @Override
 	public void setItem(int slot, @Nullable ItemStack stack)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index b4b797808..d41a4f95f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -108,6 +108,7 @@ public class TileEntityMobSpawner extends TileEntity {
                     updateDelay();
                     continue;
                 }
+                mob.spawnInit();
                 this.worldObj.entityJoinedWorld(mob);
                 for (int k = 0; k < 20; k++) {
                     double d1 = (double) this.x + 0.5D + ((double) this.worldObj.rand.nextFloat() - 0.5D) * 2D;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 0276d2e48..b2ad0861b 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -24,7 +24,6 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
@@ -323,13 +322,13 @@ public abstract class Entity
                 for (int i = 0; (float) i < 1.0F + this.bbWidth * 20F; i++) {
                     double offX = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
                     double offZ = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
-                    this.world.spawnParticle("bubble", this.x + offX, f1 + 1.0F, this.z + offZ, this.xd, this.yd - (double) (this.random.nextFloat() * 0.2F), this.zd, 0);
+                    this.world.spawnParticle("bubble", this.x + offX, f1 + 1.0F, this.z + offZ, this.xd, this.yd - (double) (this.random.nextFloat() * 0.2F), this.zd, this.world.dimension.id);
                 }
 
                 for (int j = 0; (float) j < 1.0F + this.bbWidth * 20F; j++) {
                     double offX = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
                     double offZ = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
-                    this.world.spawnParticle("splash", this.x + offX, f1 + 1.0F, this.z + offZ, this.xd, this.yd, this.zd, 0);
+                    this.world.spawnParticle("splash", this.x + offX, f1 + 1.0F, this.z + offZ, this.xd, this.yd, this.zd, this.world.dimension.id);
                 }
             }
             this.fallDistance = 0.0F;
@@ -1384,6 +1383,10 @@ public abstract class Entity
         return false;
     }
 
+    public boolean isSpawnCapExempt() {
+        return false;
+    }
+
     public static String getNameFromEntity(@NotNull Entity entity, boolean useNickname) {
         I18n translator = I18n.getInstance();
         if (entity instanceof Mob && useNickname) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
index dbc9e63d0..d8165fdbd 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
@@ -274,7 +274,7 @@ public class EntityFishingBobber extends Entity {
             }
         }
 
-        if (d5 > 0.0D) {
+        if (d5 > 0.0D && !this.world.isClientSide) {
             if (this.ticksCatchable > 0) {
                 this.ticksCatchable--;
             } else {
@@ -299,13 +299,13 @@ public class EntityFishingBobber extends Entity {
                     for (int i1 = 0; (float) i1 < 1.0F + this.bbWidth * 20F; i1++) {
                         double xOff = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
                         double zOff = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
-                        this.world.spawnParticle("bubble", this.x + xOff, f3 + 1.0F, this.z + zOff, this.xd, this.yd - (double) (this.random.nextFloat() * 0.2F), this.zd, 0);
+                        this.world.spawnParticle("bubble", this.x + xOff, f3 + 1.0F, this.z + zOff, this.xd, this.yd - (double) (this.random.nextFloat() * 0.2F), this.zd, this.world.dimension.id);
                     }
 
                     for (int j1 = 0; (float) j1 < 1.0F + this.bbWidth * 20F; j1++) {
                         double xOff = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
                         double zOff = (this.random.nextFloat() * 2.0F - 1.0F) * this.bbWidth;
-                        this.world.spawnParticle("splash", this.x + xOff, f3 + 1.0F, this.z + zOff, this.xd, this.yd, this.zd, 0);
+                        this.world.spawnParticle("splash", this.x + xOff, f3 + 1.0F, this.z + zOff, this.xd, this.yd, this.zd, this.world.dimension.id);
                     }
 
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index b21344618..18c3dc302 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -18,6 +18,7 @@ import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.joml.primitives.AABBd;
 
@@ -31,6 +32,7 @@ public class EntityItem extends Entity
     public float bobOffset;
     public int basketPickupDelay = 0;
     public static boolean enableItemClumping = true;
+    private final TilePos queryPos = new TilePos();
 
     public EntityItem(@NotNull World world, double x, double y, double z, @NotNull ItemStack itemstack) {
         super(world);
@@ -97,11 +99,24 @@ public class EntityItem extends Entity
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
-
-        if (item.getItem().hasTag(ItemTags.IS_FIRE_PROOF)) {
-            this.yd += (this.wasInWater || inLava) ? 0.02D : -0.04D;
+        boolean throughBelow = !this.world.getBlockType(this.queryPos.set(MathHelper.floor(this.x), MathHelper.floor(this.y) - 1, MathHelper.floor(this.z))).collidesWithEntity(this, this.world, this.queryPos);
+        if (this.item.getItem().hasTag(ItemTags.IS_FIRE_PROOF)) {
+            if (((this.wasInWater || inLava) && !throughBelow)) {
+                this.yd += 0.02D;
+            } else if (this.wasInWater || inLava){
+                this.yd += (-0.04D * 3.5);
+            } else {
+                this.yd += (-0.04D * 1);
+            }
         } else {
-            this.yd += this.wasInWater ? 0.02D : -0.04D;
+
+            if ((this.wasInWater && !throughBelow)) {
+                this.yd += 0.02D;
+            } else if (this.wasInWater) {
+                this.yd += (-0.04D * 3.5);
+            } else {
+                this.yd += (-0.04D * 1);
+            }
 
             if(isInLava())
             {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index bcb6319a7..0396e8bb3 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -4,7 +4,6 @@ import com.b100.utils.StringUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.material.Materials;
-import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.item.ItemFood;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.WeightedRandomLootObject;
@@ -23,7 +22,6 @@ import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
@@ -246,6 +244,11 @@ public abstract class Mob extends Entity {
     protected void onLabelled() {
     }
 
+    @Override
+    public boolean isSpawnCapExempt() {
+        return !this.nickname.isEmpty();
+    }
+
     public void setNickname(@NotNull String nickname) {
         this.nickname = nickname;
         this.hadNicknameSet = true;
@@ -340,7 +343,7 @@ public abstract class Mob extends Entity {
                     double offX = this.random.nextFloat() - this.random.nextFloat();
                     double offY = this.random.nextFloat() - this.random.nextFloat();
                     double offZ = this.random.nextFloat() - this.random.nextFloat();
-                    this.world.spawnParticle("bubble", this.x + offX, this.y + offY, this.z + offZ, this.xd, this.yd, this.zd, 0);
+                    this.world.spawnParticle("bubble", this.x + offX, this.y + offY, this.z + offZ, this.xd, this.yd, this.zd, this.world.dimension.id);
                 }
 
                 hurt(null, 2, DamageType.DROWN);
